Index: arch/ppc32/include/boot/boot.h
===================================================================
--- arch/ppc32/include/boot/boot.h	(revision 62939f75c170f1f9bc18ec3a7157792a32b0e11c)
+++ arch/ppc32/include/boot/boot.h	(revision 898d9f8c579badf050c020f550379e789204b54d)
@@ -36,5 +36,5 @@
 #define __ppc32_BOOT_H__
 
-#define BOOT_OFFSET		0x4000
+#define BOOT_OFFSET		0x8000
 
 /* Temporary stack size for boot process */
Index: arch/ppc32/src/exception.S
===================================================================
--- arch/ppc32/src/exception.S	(revision 62939f75c170f1f9bc18ec3a7157792a32b0e11c)
+++ arch/ppc32/src/exception.S	(revision 898d9f8c579badf050c020f550379e789204b54d)
@@ -117,5 +117,156 @@
 .endm
 
-.org 0x060
+.org 0x100
+.global exc_system_reset
+exc_system_reset:
+	CONTEXT_STORE
+	
+	lis r12, exc_dispatch@ha
+	addi r12, r12, exc_dispatch@l
+	mtsrr0 r12
+	
+	li r3, 0
+	b jump_to_kernel
+
+.org 0x200
+.global exc_machine_check
+exc_machine_check:
+	CONTEXT_STORE
+	
+	lis r12, exc_dispatch@ha
+	addi r12, r12, exc_dispatch@l
+	mtsrr0 r12
+	
+	li r3, 1
+	b jump_to_kernel
+
+.org 0x300
+.global exc_data_storage
+exc_data_storage:
+	CONTEXT_STORE
+	
+	lis r12, exc_dispatch@ha
+	addi r12, r12, exc_dispatch@l
+	mtsrr0 r12
+	
+	li r3, 2
+	b jump_to_kernel
+
+.org 0x400
+.global exc_instruction_storage
+exc_instruction_storage:
+	CONTEXT_STORE
+	
+	lis r12, exc_dispatch@ha
+	addi r12, r12, exc_dispatch@l
+	mtsrr0 r12
+	
+	li r3, 3
+	b jump_to_kernel
+
+.org 0x500
+.global exc_external
+exc_external:
+	CONTEXT_STORE
+	
+	lis r12, exc_dispatch@ha
+	addi r12, r12, exc_dispatch@l
+	mtsrr0 r12
+	
+	li r3, 4
+	b jump_to_kernel
+
+.org 0x600
+.global exc_alignment
+exc_alignment:
+	CONTEXT_STORE
+	
+	lis r12, exc_dispatch@ha
+	addi r12, r12, exc_dispatch@l
+	mtsrr0 r12
+	
+	li r3, 5
+	b jump_to_kernel
+
+.org 0x700
+.global exc_program
+exc_program:
+	CONTEXT_STORE
+	
+	lis r12, exc_dispatch@ha
+	addi r12, r12, exc_dispatch@l
+	mtsrr0 r12
+	
+	li r3, 6
+	b jump_to_kernel
+
+.org 0x800
+.global exc_fp_unavailable
+exc_fp_unavailable:
+	CONTEXT_STORE
+	
+	lis r12, exc_dispatch@ha
+	addi r12, r12, exc_dispatch@l
+	mtsrr0 r12
+	
+	li r3, 7
+	b jump_to_kernel
+
+.org 0x900
+.global exc_decrementer
+exc_decrementer:
+	CONTEXT_STORE
+
+	lis r12, exc_dispatch@ha
+	addi r12, r12, exc_dispatch@l
+	mtsrr0 r12
+	
+	li r3, 8
+	b jump_to_kernel
+
+.org 0xa00
+.global exc_reserved0
+exc_reserved0:
+	CONTEXT_STORE
+	
+	lis r12, exc_dispatch@ha
+	addi r12, r12, exc_dispatch@l
+	mtsrr0 r12
+	
+	li r3, 9
+	b jump_to_kernel
+
+.org 0xb00
+.global exc_reserved1
+exc_reserved1:
+	CONTEXT_STORE
+	
+	lis r12, exc_dispatch@ha
+	addi r12, r12, exc_dispatch@l
+	mtsrr0 r12
+	
+	li r3, 10
+	b jump_to_kernel
+
+.org 0xc00
+.global exc_syscall
+exc_syscall:
+	CONTEXT_STORE	
+	
+	b jump_to_kernel_syscall
+
+.org 0xd00
+.global exc_trace
+exc_trace:
+	CONTEXT_STORE
+	
+	lis r12, exc_dispatch@ha
+	addi r12, r12, exc_dispatch@l
+	mtsrr0 r12
+	
+	li r3, 12
+	b jump_to_kernel
+
+.org 0x4000
 jump_to_kernel:
 	lis r12, iret@ha
@@ -148,153 +299,2 @@
 	addis sp, sp, 0x8000
 	rfi
-
-.org 0x100
-.global exc_system_reset
-exc_system_reset:
-	CONTEXT_STORE
-	
-	lis r12, exc_dispatch@ha
-	addi r12, r12, exc_dispatch@l
-	mtsrr0 r12
-	
-	li r3, 0
-	b jump_to_kernel
-
-.org 0x200
-.global exc_machine_check
-exc_machine_check:
-	CONTEXT_STORE
-	
-	lis r12, exc_dispatch@ha
-	addi r12, r12, exc_dispatch@l
-	mtsrr0 r12
-	
-	li r3, 1
-	b jump_to_kernel
-
-.org 0x300
-.global exc_data_storage
-exc_data_storage:
-	CONTEXT_STORE
-	
-	lis r12, exc_dispatch@ha
-	addi r12, r12, exc_dispatch@l
-	mtsrr0 r12
-	
-	li r3, 2
-	b jump_to_kernel
-
-.org 0x400
-.global exc_instruction_storage
-exc_instruction_storage:
-	CONTEXT_STORE
-	
-	lis r12, exc_dispatch@ha
-	addi r12, r12, exc_dispatch@l
-	mtsrr0 r12
-	
-	li r3, 3
-	b jump_to_kernel
-
-.org 0x500
-.global exc_external
-exc_external:
-	CONTEXT_STORE
-	
-	lis r12, exc_dispatch@ha
-	addi r12, r12, exc_dispatch@l
-	mtsrr0 r12
-	
-	li r3, 4
-	b jump_to_kernel
-
-.org 0x600
-.global exc_alignment
-exc_alignment:
-	CONTEXT_STORE
-	
-	lis r12, exc_dispatch@ha
-	addi r12, r12, exc_dispatch@l
-	mtsrr0 r12
-	
-	li r3, 5
-	b jump_to_kernel
-
-.org 0x700
-.global exc_program
-exc_program:
-	CONTEXT_STORE
-	
-	lis r12, exc_dispatch@ha
-	addi r12, r12, exc_dispatch@l
-	mtsrr0 r12
-	
-	li r3, 6
-	b jump_to_kernel
-
-.org 0x800
-.global exc_fp_unavailable
-exc_fp_unavailable:
-	CONTEXT_STORE
-	
-	lis r12, exc_dispatch@ha
-	addi r12, r12, exc_dispatch@l
-	mtsrr0 r12
-	
-	li r3, 7
-	b jump_to_kernel
-
-.org 0x900
-.global exc_decrementer
-exc_decrementer:
-	CONTEXT_STORE
-
-	lis r12, exc_dispatch@ha
-	addi r12, r12, exc_dispatch@l
-	mtsrr0 r12
-	
-	li r3, 8
-	b jump_to_kernel
-
-.org 0xa00
-.global exc_reserved0
-exc_reserved0:
-	CONTEXT_STORE
-	
-	lis r12, exc_dispatch@ha
-	addi r12, r12, exc_dispatch@l
-	mtsrr0 r12
-	
-	li r3, 9
-	b jump_to_kernel
-
-.org 0xb00
-.global exc_reserved1
-exc_reserved1:
-	CONTEXT_STORE
-	
-	lis r12, exc_dispatch@ha
-	addi r12, r12, exc_dispatch@l
-	mtsrr0 r12
-	
-	li r3, 10
-	b jump_to_kernel
-
-.org 0xc00
-.global exc_syscall
-exc_syscall:
-	CONTEXT_STORE	
-	
-	b jump_to_kernel_syscall
-
-.org 0xd00
-.global exc_trace
-exc_trace:
-	CONTEXT_STORE
-	
-	lis r12, exc_dispatch@ha
-	addi r12, r12, exc_dispatch@l
-	mtsrr0 r12
-	
-	li r3, 12
-	b jump_to_kernel
Index: arch/ppc32/src/mm/frame.c
===================================================================
--- arch/ppc32/src/mm/frame.c	(revision 62939f75c170f1f9bc18ec3a7157792a32b0e11c)
+++ arch/ppc32/src/mm/frame.c	(revision 898d9f8c579badf050c020f550379e789204b54d)
@@ -63,6 +63,7 @@
 	}
 
-	/* First is exception vector, second is 'implementation specific', third and fourth is reserved */
-	frame_mark_unavailable(0, 4);
+	/* First is exception vector, second is 'implementation specific',
+	   third and fourth is reserved, other contain real mode code */
+	frame_mark_unavailable(0, 8);
 	
 }
Index: kernel.config
===================================================================
--- kernel.config	(revision 62939f75c170f1f9bc18ec3a7157792a32b0e11c)
+++ kernel.config	(revision 898d9f8c579badf050c020f550379e789204b54d)
@@ -99,5 +99,5 @@
 
 # Power off on halt
-! [ARCH=ppc32] CONFIG_POWEROFF (y/n)
+! [ARCH=ppc32] CONFIG_POWEROFF (n/y)
 
 ## Debugging configuration directives