Index: uspace/drv/hid/usbhid/usbhid.c
===================================================================
--- uspace/drv/hid/usbhid/usbhid.c	(revision 745a3f1cffba149c167b6eaa37f53857d4ec024d)
+++ uspace/drv/hid/usbhid/usbhid.c	(revision 957ea3a5214cbbd5b086171e4b7e8cd700bae8c8)
@@ -134,5 +134,5 @@
 	usb_hid_report_path_t *usage_path = usb_hid_report_path();
 	if (usage_path == NULL) {
-		usb_log_debug("Failed to create usage path.\n");
+		usb_log_debug("Failed to create usage path.");
 		return false;
 	}
@@ -143,5 +143,5 @@
 		    mapping->usage_path[i].usage_page,
 		    mapping->usage_path[i].usage) != EOK) {
-			usb_log_debug("Failed to append to usage path.\n");
+			usb_log_debug("Failed to append to usage path.");
 			usb_hid_report_path_free(usage_path);
 			return false;
@@ -149,5 +149,5 @@
 	}
 
-	usb_log_debug("Compare flags: %d\n", mapping->compare);
+	usb_log_debug("Compare flags: %d", mapping->compare);
 
 	bool matches = false;
@@ -155,5 +155,5 @@
 
 	do {
-		usb_log_debug("Trying report id %u\n", report_id);
+		usb_log_debug("Trying report id %u", report_id);
 		if (report_id != 0) {
 			usb_hid_report_path_set_report_id(usage_path,
@@ -166,5 +166,5 @@
 		        USB_HID_REPORT_TYPE_INPUT);
 
-		usb_log_debug("Field: %p\n", field);
+		usb_log_debug("Field: %p", field);
 
 		if (field != NULL) {
@@ -243,5 +243,5 @@
 			    mapping->product_id);
 			if (usb_hid_ids_match(hid_dev, mapping)) {
-				usb_log_debug("IDs matched.\n");
+				usb_log_debug("IDs matched.");
 				matched = true;
 			}
@@ -250,5 +250,5 @@
 		/* Check usage match. */
 		if (mapping->usage_path != NULL) {
-			usb_log_debug("Comparing device against usage path.\n");
+			usb_log_debug("Comparing device against usage path.");
 			if (usb_hid_path_matches(hid_dev, mapping)) {
 				/* Does not matter if IDs were matched. */
@@ -258,5 +258,5 @@
 
 		if (matched) {
-			usb_log_debug("Subdriver matched.\n");
+			usb_log_debug("Subdriver matched.");
 			subdrivers[count++] = &mapping->subdriver;
 		}
@@ -285,5 +285,5 @@
 		    usb_device_get_mapped_ep_desc(dev, endpoints[i].desc);
 		if (epm && epm->present) {
-			usb_log_debug("Found: %s.\n", endpoints[i].description);
+			usb_log_debug("Found: %s.", endpoints[i].description);
 			hid_dev->poll_pipe_mapping = epm;
 			return EOK;
@@ -301,16 +301,16 @@
 
 	do {
-		usb_log_debug("Getting size of the report.\n");
+		usb_log_debug("Getting size of the report.");
 		const size_t size =
 		    usb_hid_report_byte_size(&hid_dev->report, report_id,
 		        USB_HID_REPORT_TYPE_INPUT);
-		usb_log_debug("Report ID: %u, size: %zu\n", report_id, size);
+		usb_log_debug("Report ID: %u, size: %zu", report_id, size);
 		max_size = (size > max_size) ? size : max_size;
-		usb_log_debug("Getting next report ID\n");
+		usb_log_debug("Getting next report ID");
 		report_id = usb_hid_get_next_report_id(&hid_dev->report,
 		    report_id, USB_HID_REPORT_TYPE_INPUT);
 	} while (report_id != 0);
 
-	usb_log_debug("Max size of input report: %zu\n", max_size);
+	usb_log_debug("Max size of input report: %zu", max_size);
 
 	assert(hid_dev->input_report == NULL);
@@ -329,5 +329,5 @@
 {
 	if (dev == NULL || arg == NULL || buffer == NULL) {
-		usb_log_error("Missing arguments to polling callback.\n");
+		usb_log_error("Missing arguments to polling callback.");
 		return false;
 	}
@@ -336,5 +336,5 @@
 	assert(hid_dev->input_report != NULL);
 
-	usb_log_debug("New data [%zu/%zu]: %s\n", buffer_size,
+	usb_log_debug("New data [%zu/%zu]: %s", buffer_size,
 	    hid_dev->max_input_report_size,
 	    usb_debug_str_buffer(buffer, buffer_size, 0));
@@ -419,5 +419,5 @@
 	assert(dev);
 
-	usb_log_debug("Initializing HID structure...\n");
+	usb_log_debug("Initializing HID structure...");
 
 	usb_hid_report_init(&hid_dev->report);
@@ -441,10 +441,10 @@
 		usb_hid_find_subdrivers(hid_dev);
 	} else {
-		usb_log_error("Failed to parse report descriptor: fallback.\n");
+		usb_log_error("Failed to parse report descriptor: fallback.");
 		hid_dev->subdrivers = NULL;
 		hid_dev->subdriver_count = 0;
 	}
 
-	usb_log_debug("Subdriver count(before trying boot protocol): %d\n",
+	usb_log_debug("Subdriver count(before trying boot protocol): %d",
 	    hid_dev->subdriver_count);
 
@@ -457,5 +457,5 @@
 		switch (hid_dev->poll_pipe_mapping->interface->interface_protocol) {
 		case USB_HID_PROTOCOL_KEYBOARD:
-			usb_log_info("Falling back to kbd boot protocol.\n");
+			usb_log_info("Falling back to kbd boot protocol.");
 			rc = usb_kbd_set_boot_protocol(hid_dev);
 			if (rc == EOK) {
@@ -464,5 +464,5 @@
 			break;
 		case USB_HID_PROTOCOL_MOUSE:
-			usb_log_info("Falling back to mouse boot protocol.\n");
+			usb_log_info("Falling back to mouse boot protocol.");
 			rc = usb_mouse_set_boot_protocol(hid_dev);
 			if (rc == EOK) {
@@ -471,10 +471,10 @@
 			break;
 		default:
-			usb_log_info("Falling back to generic HID driver.\n");
+			usb_log_info("Falling back to generic HID driver.");
 			usb_hid_set_generic_hid_subdriver(hid_dev);
 		}
 	}
 
-	usb_log_debug("Subdriver count(after trying boot protocol): %d\n",
+	usb_log_debug("Subdriver count(after trying boot protocol): %d",
 	    hid_dev->subdriver_count);
 
@@ -491,5 +491,5 @@
 	for (unsigned i = 0; i < hid_dev->subdriver_count; ++i) {
 		if (hid_dev->subdrivers[i].init != NULL) {
-			usb_log_debug("Initializing subdriver %d.\n",i);
+			usb_log_debug("Initializing subdriver %d.",i);
 			const int pret = hid_dev->subdrivers[i].init(hid_dev,
 			    &hid_dev->subdrivers[i].data);
@@ -514,5 +514,5 @@
 		rc = usb_hid_init_report(hid_dev);
 		if (rc != EOK) {
-			usb_log_error("Failed to initialize input report buffer: %s\n", str_error(rc));
+			usb_log_error("Failed to initialize input report buffer: %s", str_error(rc));
 			// FIXME: What happens now?
 		}
@@ -520,5 +520,5 @@
 		usb_polling_t *polling = &hid_dev->polling;
 		if ((rc = usb_polling_init(polling))) {
-			usb_log_error("Failed to initialize polling: %s\n", str_error(rc));
+			usb_log_error("Failed to initialize polling: %s", str_error(rc));
 			// FIXME: What happens now?
 		}
@@ -555,5 +555,5 @@
 	usb_polling_fini(&hid_dev->polling);
 
-	usb_log_debug("Subdrivers: %p, subdriver count: %d\n",
+	usb_log_debug("Subdrivers: %p, subdriver count: %d",
 	    hid_dev->subdrivers, hid_dev->subdriver_count);
 